:- ensure_loaded( '../../src/init_lib' ).

:- requires( read_term_frequencies/2 ).
:- requires( write_terms/2 ).

data_n_to_arity_two( One ) :-
     ( atomic(One) -> 
          file_name_extension( Stem, pl, One ),
          In = One, 
          atom_concat( Stem, '_mpl', MplStem ),
          file_name_extension( MplStem, pl, Out )
          ;
          ( One = [In,Out] -> 
               true
               ;
               One = [In],
               file_name_extension( Stem, pl, In ),
               atom_concat( Stem, '_mpl', MplStem ),
               file_name_extension( MplStem, pl, Out )

          )
     ),
     data_n_to_arity_two( In, Out ).

data_n_to_arity_two( In, Out ) :-
     read_term_frequencies( In, Freqs ),
     findall( Datum, (
                         member(D-T,Freqs),
                         functor( D, data, _ ),
                         D =.. [data|Dargs],
                         Datum = data(Dargs,T)
                     ), 
                         Data ),
     findall( Tms, (member(Dt,Data),arg(2,Dt,Tms)), AllTms ),
     sumlist( AllTms, Tot ),
     write( tot(Tot) ), nl,
     write_terms( Out, Data ).
