
:- ensure_loaded( library(lists) ).		% memberchk/2.
:- ensure_loaded( '../../src/init_lib' ).

:- requires( opts_select_infiles/3 ).
:- requires( option_required/2 ).

report_monotone( Opts ) :-
	opts_select_infiles( Opts, Fs, NonFOpts ),
	option_required( clust(Clust), NonFOpts ),
	option_required( pos(Pos), NonFOpts ),
	report_monotone_1( Fs, Clust, Pos ).

report_monotone_1( [], _Clust, _Pos ).
report_monotone_1( [F|Fs], Clust, Pos ) :-
	write( file-F ), nl,
	open( F, read, In ),
	read( In, Fst ),
	functor( Fst, _Name, CshPos ),
	arg( Clust , Fst, CuVl ),
	% arg( Pos   , Fst, PosVl   ),
	% arg( CshPos, Fst, CshVl   ),
	% Acc = [PosVl-CshVl],
	Acc = [],
	C = Clust/Pos/CshPos,
	position_clusters_positions_on_stream( Fst, In, C, CuVl, Acc, Clusters ),
	report_monotone_in_clusters( Clusters ),
	close( In ),
	report_monotone_1( Fs, Clust, Pos ).

position_clusters_positions_on_stream( end_of_file, _In, _C, L, Acc, Clusters ) :-
	reverse( Acc, RevAcc ),
	Clusters = [L-RevAcc].
position_clusters_positions_on_stream( Term, In, C/P/S, Lst, Acc, Clusters ) :-
	arg( C, Term, NxtL  ),
	arg( P, Term, PosVl ),
	arg( S, Term, CshVl ),
	( NxtL == Lst -> 
		Clusters = TClusters,
		NxtA     = [PosVl-CshVl|Acc]
		;
		reverse( Acc, RevAcc ),
		Clusters = [Lst-RevAcc|TClusters],
		NxtA     = [PosVl-CshVl]
	),
	read( In, NxtT ),
	position_clusters_positions_on_stream( NxtT, In, C/P/S, NxtL, NxtA, TClusters ).

report_monotone_in_clusters( [] ).
report_monotone_in_clusters( [Id-Clust|TPrs] ) :-
	Clust = [H|T],
	( a_monotone_cluster(T,H,Mono) ->
		write( Id-Mono-Clust ), nl
		;
		true
	),
	report_monotone_in_clusters( TPrs ).

a_monotone_cluster( [], _Lst, Mono ) :-
	( var(Mono) -> Mono = (<>); true ).
a_monotone_cluster( [H|T], Lst, Mono ) :-
	compare( Op, H, Lst ),
	( Op = (=) -> true; Mono = Op ),
	a_monotone_cluster( T, H, Mono ).
