
:- elm( 'src/model_type_calls' ).

:- ensure_loaded( library(lists) ).          % memberchk/2.

:- requires( read_terms/2 ).
:- requires( werr/2 ).

data_calls_from_stats_file( BareFile, ModType ) :-
     atom_concat( BareFile, '.stats', StatsFile ),
     read_terms( StatsFile, StatsTerms ),
     memberchk( model_type(ModType), StatsTerms ),
     model_type_calls( ModType ),
     memberchk( data_file(DataFile), StatsTerms ),
     memberchk( data_call(DataCall), StatsTerms ),
     werr( loading(DataFile), info ), 
     ensure_loaded( DataFile ),
     werr( callling(DataCall), info ),
     call( DataCall ).
