:- ensure_loaded( '../../src/init_lib' ).

:- ensure_loaded( library(delete_file_if) ).			% /1.
:- ensure_loaded( library(fname_extension) ).		% /5.
:- ensure_loaded( library(bn_to_dot_dag) ).			% /3.
:- ensure_loaded( library(sys_info) ).				% /1.
:- ensure_loaded( library(lists) ).				% memberchk/2.

/*
bn_to_eps( [1-[],2-[1],3-[2,5],4-[],5-[4],6-[4],7-[3],8-[3,6]], tara, [] ).
bn_to_eps( [1-[],2-[1],3-[2,5],4-[],5-[4],6-[4],7-[3],8-[3,6]], an_file, [node_style(empty)] ).
*/
bn_to_eps( Bn, EpsFile, Opts ) :-
	fname_extension( EpsFile, ".eps", Stem, Eps, _ ),
	atom_concat( Stem, '.dot', DotFile ),
	bn_to_dot_dag( Bn, Bn, DotFile, Opts ),
	% atom_concat( 'doted -Tps -o ', 
	atom_concat( ' ', DotFile, Dot1 ),
	atom_concat( Eps, Dot1, Dot2 ),
	atom_concat( ' -o ', Dot2, Dot25 ),
	( memberchk(cline(Cline),Opts) ->
		atom_concat( Cline, ' ', LPCline ),
		atom_concat( ' ', LPCline, PCline ),
		atom_concat( PCline, Dot25, Dot3 )
		;
		Dot3 = Dot25
	),
	atom_concat( 'dot -Tps ', Dot3, Dot ),
	sys_info( Dot ),
	( memberchk(delete(false),Opts) ->
		true
		;
		delete_file_if(DotFile)
	).

