/* 
     for each file that ends in bayes in current directory, 
     write the counts for the majority classes 
     */

:- ensure_loaded( library(apply_macros) ).

:- requires( directory_files/2 ).
:- requires( kv_vs/2 ).
:- requires( atoms_postfix_stems/3 ).
:- requires( mould_item_list/3).
:- requires( max_at/3 ).

count_bayes :-
     directory_files( '.', Files ),
     atoms_postfix_stems( Files, '_bayes', Stems ),
     write( stems(Stems) ), nl, nl, nl,
     checklist( count_bayes_1, Stems ).

count_bayes_1( Stem ) :-
     % write( doing(Stem ) ), nl,
     atom_concat( Stem, '_bayes', File ),
     open( File, read, In ),
     read( In, Fst ),
     mould_item_list( Fst, 0, Cnts ),
     count_bayes_stream( Fst, Cnts, In, Tot ), 
     write( File:Tot ), nl,
     close( In ).

count_bayes_stream( end_of_file, Cnts, _In, Tot ) :-
     !,
     Tot = Cnts.
count_bayes_stream( KVList, Cnts, In, Tot ) :-
     % trace,
     kv_vs( KVList, Vs ),
     max_at( Vs, _Max, At ),
     nth_addition( At, Cnts, 1, NxtCnts ),
     read( In, Next ),
     count_bayes_stream( Next, NxtCnts, In, Tot ).

nth_addition( 1, [H|T], Add, Cnts ) :-
     NxH is H + Add,
     Cnts = [NxH|T].
nth_addition( N, [H|T], Add, [H|Cnts] ) :-
     NxN is N - 1,
     nth_addition( NxN, T, Add, Cnts ).
