:- ensure_loaded( '../../src/init_lib' ).
:- ensure_loaded( library(ordsets) ). 		% ord_add_element/3.
:- ensure_loaded( library(nth_replace) ).	% /5.
:- ensure_loaded( library(write_list_elem_per_line) ).	% /3.
:- requires( kvs_add_v_to_matching_k/4 ).

% report all values for each feature, and the categories.
% assumes data of the form data/n are in-file File.
% now it prints frequencies too.

data_contain( [File] ) :-
	open( File, read, In ),
	read( In, First ), 
	functor( First, data, N ),
	n_empty_lists( N, EmptyLists ),
	data_contain_read( First, In, N, EmptyLists, Contain ),
	data_contain_report( Contain ),
	close( In ).

data_contain_read( end_of_file, _In, _N, Acc, Contain ) :-
	!,
	Acc = Contain.
data_contain_read( Term, In, N, Acc, Contain ) :-
	term_contain_read( N, Term, Acc, NxAcc ),
	read( In, NxtTerm ),
	data_contain_read( NxtTerm, In, N, NxAcc, Contain ).

term_contain_read( 0, _Term, List, List ).
term_contain_read( I, Term, InList, OutList ) :-
	arg( I, Term, IthArg ),
	nth_replace( I, InList, NthNew, NthOld, MidList ),
	% ord_add_element( NthOld, IthArg, NthNew ),
	kvs_add_v_to_matching_k( NthOld, IthArg, 1, NthNew ),
	RedI is I - 1,
	term_contain_read( RedI, Term, MidList, OutList ).

n_empty_lists( 1, EmptyLists ) :-
	!,
	EmptyLists = [[]].
n_empty_lists( I, [[]|T] ) :-
	RedI is I - 1,
	n_empty_lists( RedI, T ).

data_contain_report( Contain ) :-
	write_list_elem_per_line( Contain ).
