:- module( edit, [variable_has_position_in_cart/3,edcart_to_concrete_cart/2,
				feature_choice_splits_ids/3,navigate/7] ).

feature_choice_splits_ids( F, Ch, AllLeftIds ) :-
	Idx is F * 11 + Ch,
	feature_choice_t( Idx, AllLeftIds ).

% Position could be stored in LeavesList
variable_has_position_in_cart( Cart, Var, Position ) :-
	var( Cart ),
	!,
	Cart == Var,
	Position = []. % else, fail = is not here 
variable_has_position_in_cart( cart(_,_,_,L,R), Var, Position ) :-
	( variable_has_position_in_cart(L,Var,TPosition) -> 
		Position = [l|TPosition]
		;
		variable_has_position_in_cart( R, Var, TPosition ),
		!,
		Position = [r|TPosition]
	).

edcart_to_concrete_cart( ec(Cart,Lvs,_Psts), CartOut ) :-
	instantiate_leaves( Lvs ),
	five_arg_cart_to_four_arg( Cart, CartOut ).

instantiate_leaves( [] ).
instantiate_leaves( [H-H|T] ) :-
	instantiate_leaves( T ).

five_arg_cart_to_four_arg( cart(Ft,Ch,_Poss,L,R), cart(Ft,Ch,FrL,FrR) ) :-
	!,
	five_arg_cart_to_four_arg( L, FrL ),
	five_arg_cart_to_four_arg( R, FrR ).

navigate( cart(F,Ch,Poss,L,R), Psts, CurD, PruneNode, D, PrunedCart, ConnctVar ) :-
	( Psts = [H|T] -> 
		NxD is CurD + 1,
		( H = l ->
			navigate( L, T, NxD, PruneNode, D, PrndL, ConnctVar ),
			PrunedCart = cart(F,Ch,Poss,PrndL,R)
			;
			navigate( R, T, NxD, PruneNode, D, PrndR, ConnctVar ),
			PrunedCart = cart(F,Ch,Poss,L,PrndR)
		)
		;
		D = CurD,
		PruneNode = cart(F,Ch,Poss,L,R),
		PrunedCart = ConnctVar
	).
