agg_path( [] ).
agg_path( [H|T] ) :-
	atom_concat( 'agg_', H, AggH ),
	open( H, read, In ), 
	open( AggH, write, Out ), 
	read( In, Term ),
	agg_path_stream( Term, In, Out ),
	close( In ),
	close( Out ),
	agg_path( T ).

agg_path_stream( end_of_file, _In, _Out ) :- !.
agg_path_stream( p(Path), In, Out ) :-
	agg_this_path( Path, 999, 0, AggPath ),
	write( Out, a(AggPath) ), write( Out, '.' ), nl(Out),
	read( In, Term ),
	agg_path_stream( Term, In, Out ).

agg_this_path( [], Last, Tms, [Last-Tms] ).
agg_this_path( [H|T], Last, Tms, AggPath ) :-
	( var(H) -> write( user_error, found_variable_in_path ),
			  nl( user_error ), abort
			  ; true ),
	( (H = Id/_Prb; H = Id:_Prb) -> 
		( Last == Id -> 
			This = Last, ThisTms is Tms + 1,
			TAggPath = AggPath
			;
			This = Id, ThisTms is 1,
			AggPath = [Last-Tms|TAggPath]
		)
		;
		( number(H) ->
			( Last =:= 0 ->
				This = Last, ThisTms is Tms + 1,
				TAggPath = AggPath
				;
				This = 0, ThisTms is 1,
				AggPath = [Last-Tms|TAggPath]
			)
			; 
			write( user_error, unknow_id_str(H) ), 
			nl( user_error ), abort
		)
	),
	agg_this_path( T, This, ThisTms, TAggPath ).
