
/* 
      The final steps in preparing datastructures for the Boutros dataset
   as expected in the $mcmcms/nem/src/llhood/nem_mll.pl 

   */

:- ensure_loaded( mll_data_boutros_d0 ).
:- ensure_loaded( mll_data_boutros_d1 ).

:- ensure_loaded( library(matrix) ).        % matrix_new/4
:- ensure_loaded( library(lists) ).         % flatten/2

nem_parameter( alpha, 0.13 ).
nem_parameter( beta, 0.05 ).

boutros_matrix :- 
     ( current_predicate(nem_d0/1) ->
          true
          ;
          findall( [V1,V2,V3,V4], d0_row(V1,V2,V3,V4), Nested ),
          length( Nested, R ),
          flatten( Nested, Flat ),
          C is 4,
          PePop is R * C,
          findall( 0.25, between(1,PePop,_), Qs ),
          matrix_new( floats, [1,PePop], Qs, Pe ),
          % assert( nem_pe(false) ), % use this to skip last mLL multiplication...
          assert( nem_pe( Pe ) ),
          Dims = [R,C],
          matrix_new( ints, Dims, Flat, D0 ),
          assert( nem_d0(D0) ),
          findall( [V1,V2,V3,V4], d1_row(V1,V2,V3,V4), Nested1 ),
          flatten( Nested1, Flat1 ),
          % we are reusing R, should be the same... hmm.. better double check
          % following will fail if that is not the case
          length( Nested1, R ),
          matrix_new( ints, Dims, Flat1, D1 ),
          assert( nem_d1(D1) ),
          %
          matrix_new( ints, [C,C], Phi ),
          matrix_new( ints, [C,C], Chi ),
          assert( nem_phi_chi( Phi, Chi ) ),
          %
          matrix_new( floats, Dims, D1Chi ),
          matrix_new( floats, Dims, D0Chi ),
          matrix_new( floats, Dims, D1Phi ),
          matrix_new( floats, Dims, D0Phi ),
          assert( nem_d1_d0_chi_phi(D1Chi,D0Chi,D1Phi,D0Phi) )
     ).

:- boutros_matrix.
