:- ensure_loaded( '../../src/init_lib' ).
:- requires( directory_files_regular/2 ).
:- requires( file_stems_of_files_with_this_ext/3 ).
:- requires( sys_info/1 ).

chains_rerun_losses :-
	directory_files_regular( '.', RegFiles ),
	file_stems_of_files_with_this_ext( RegFiles, '.gz', GzStems ),
	chain_files_to_rerun_losses_files( GzStems ).

chain_files_to_rerun_losses_files( [] ).
chain_files_to_rerun_losses_files( [HStem|TStems] ) :-
	atom_concat( HStem, '.gz', HGz ),
	atom_concat( 'gunzip ', HGz, Gunzip ),
	sys_info( Gunzip ),
     atom_concat( 'upsh p chain_rerun_losses ', HStem, UpshRerun ),
     % atom_concat( 'upsh p chain_to_bst_mst ', HGz, UpshBstMst ),
	sys_info( UpshRerun ),
	atom_concat( 'gzip ', HStem, Gzip ),
	sys_info( Gzip ),
	% atom_concat( 'upsh p chain_bst_mst_to_losses ', HStem, UpshLosses ),
	% sys_info( UpshLosses ),
	chain_files_to_rerun_losses_files( TStems ).
