
:- ensure_loaded( library(lists) ).				% memberchk/2, append/3.
:- ensure_loaded( '../../src/init_lib' ).			% requires/1.

:- ensure_loaded( post_loss ).					% /1.
:- ensure_loaded( loss_files_to_exp_loss_points ).	% /1.
:- ensure_loaded( '../../auxil/gsplay' ).			% /1, gzip_files/1.

:- requires( opts_have_help/1 ).

new_loss_exp_plots( Opts ) :-
	opts_have_help( Opts ),
	!, nl,
	write( 'new_loss_exp_plots     runs three consecutive scripts to generate' ), nl,
	write( '                       expectation point plots for new loss functions' ), nl,
	write( '                       from existing model files. In general it is ' ), nl,
	write( '                       advisable to run the three separate scripts,' ), nl,
	write( '                       post_loss, loss_files_to_exp_loss_points and' ), nl, 
	write( '                       gsplay, on their own.' ), nl, nl,
	write( ' Options.' ), nl,
	write( '        compress/1     boolean, true value gzips loss and point files.' ), nl, 
	write( '        mcmc/1         chain file to process. Multiple allowed.' ), nl, 
	write( '                       Each should contain the output models of an mcmcms run.' ), nl, 
	write( '        loss/2         The loss functions to use and its abbreviation.' ), nl,
	write( '        load/1         Load these files. Usually because they contain' ), nl,
	write( '                       loss function definitions or true models.' ), nl, nl,
	write( '        step/1         declares every how many models expected values' ), nl, 
	write( '                       should be computed.' ), nl, nl,
	write( ' All gsplot.pl options are allowed.' ), nl, nl,
	write( ' Example: ' ), nl,
	write( 'upsh new_loss_exp_plots mcmc=atm=../models/cm_tia_d100_mrm_buc_r100_pts_hua_s1.gz loss=loss_ck,ck load=atm=../loss load=atm=../simple rm=false' ), nl, nl.



new_loss_exp_plots( Opts ) :-
	post_loss( [compress(false),out(LFs)|Opts] ),
	loss_files_to_exp_loss_points( [lfile(LFs),compress(false),out(EFs)|Opts] ),
	append( Opts, EFs, GsOpts ),
	gsplay( GsOpts ),
	( memberchk(compress(true),Opts) -> gzip_files( LFs ), gzip_files( EFs ) ; true ).
