:- ensure_loaded( library(lists) ).		%.
:- ensure_loaded( library(ordsets) ).		%.

the_true_bn_str_of( Tr, TBn ) :-
	the_true_bn_str_of( Tr, _Nds, TBn ).

the_true_bn_str_of( Tr, Nds, TBn ) :-
     ensure_slp_extension( Tr, TrExt ),
	( file_exists(TrExt) -> 
		TrFile = TrExt
		;
          atom_concat( 'true/', TrExt, PrvFile2 ),
          ( file_exists(PrvFile2) ->
               TrFile = PrvFile2
               ;
		     atom_concat( '../true', TrExt, TrFile )
          )
	),
	open( TrFile, read, In ),
	sample_clause_on_stream( In, SBody ),
	close( In ),
	body_to_p_list( SBody, Plist ),
	the_true_structure_of( Plist, 1, [], Nds, UnsTBn ),
	sort( UnsTBn, TBn ).

ensure_slp_extension( File, SlpFile ) :-
     ( atom_concat(_, '.slp', File) ->
          SlpFile = File
          ;
          atom_concat( File, '.slp', SlpFile )
     ).

sample_clause_on_stream( In, Body ) :-
	read( In, Term ), 
	( Term = (sample(_Vars) :- Body) -> 
		true
		; 
		sample_clause_on_stream( In, Body )
	).

body_to_p_list( (A,B), List ) :-
	!,
	% A =.. [Name|_Args],
	functor( A, Name, _Arity ),
	( atom_concat(p_,_,Name) -> List = [A|T] ; List = T ),
	body_to_p_list( B, T ).
body_to_p_list( A, List  ) :-
	functor( A, Name, _Arity ),
	( atom_concat(p_,_,Name) -> List = [A] ; List = [] ).

the_true_structure_of( [], _N, TBn, [], TBn ).
the_true_structure_of( [H|T], N, Acc, [N|TNds], TBn ) :-
% the_true_structure_of( [p(X,X,PaX)|T], Acc, TBn ) :-
	H =.. [_Name,N,PaX],
	% atom_concat( p_, AtmX, Name ),
	% atom_codes( AtmX, CsX ),
	% number_codes( X, CsX ),
	% ( ground(PaX) -> 
		NxT = T,
		add_edges_towards_from_all( PaX, N, Acc, NxAcc ),

		% ;
		% NxAcc = Acc,
		% append( T,[H], NxT )
	% ),
	NxN is N + 1,
	the_true_structure_of( NxT, NxN, NxAcc, TNds, TBn ).

add_edges_towards_from_all( [], _X, All, All ).
add_edges_towards_from_all( [H|T], X, Acc, All ) :-
	ord_add_element( Acc, H-X, NxAcc ),
	add_edges_towards_from_all( T, X, NxAcc, All ).
