:- ensure_loaded( library(random) ).		% setrand/1.
:- setrand( rand(6548,19229,23110) ). % seed id 1.

/* 
% comparison_data(LossFs,TrueM,DataSize,ModSpace,BStg,RunLgth,Prior,Lkhood,SeedId,StrGoal).

% comparison_data( [loss_01,loss_eg_01,loss_ck,loss_ks,loss_naive_edgecount], asia, 10000, rm, cd(0), 100, '../bns/slps/bn_un_any_6h34.slp', '../bns/src/llhood/lhood_canonical_bdeu.pl', 1, TS, bn/[Nats] ) :-
comparison_data( Losses, asia, 10000, rm, cd(0), I, '../bns/slps/bn_or_any_pick_ahalf_6h34.slp', '../bns/src/llhood/lhood_canonical_bdeu.pl', 1, TS, bn/[Nats] ) :-
	Losses = [loss_01,loss_eg_01,loss_ck,loss_ks,loss_naive_edgecount],
	I = 10000000, 
	TS = ds_of_two_to_script,
 	list_of_first_n_nats( 8, [], Nats ).

comparison_data( Losses, asia, 10000, rm, sc, I, '../bns/slps/bn_or_any_pick_ahalf_6h34.slp', '../bns/src/llhood/lhood_canonical_bdeu.pl', 1, TS, bn/[Nats] ) :-
	I = 10000000,
	Losses = [loss_01,loss_eg_01,loss_ck,loss_ks,loss_naive_edgecount],
	TS = ds_of_two_to_script,
 	list_of_first_n_nats( 8, [], Nats ).

*/

comparison_data( Losses, asia, 10000, rm, uc, I, '../bns/slps/bn_or_any_pick_ahalf_6h34.slp', '../bns/src/llhood/lhood_canonical_bdeu.pl', 1, TS, XFs, bn/[Nats] ) :-
	I = 10000000,
	Losses = [loss_01,loss_eg_01,loss_ck,loss_ks,loss_naive_edgecount],
	TS = ds_of_two_to_script,
	XFs = [cp('auxil/bns_scm.pl','auxil/')],
 	list_of_first_n_nats( 8, [], Nats ).

% Also need to define, loss_id/2, model_id/2, prior_id/2, lhood_id/2.
% These provide shorthands of the respective comparison_data/n entries
% which will appear in the results directories.
loss_id( loss_01, id ).    % identity
loss_id( loss_eg_01, ed ). % equivalence class identity
loss_id( loss_ck, ck ).    % Castelo and Ko\v{c}ka
loss_id( loss_ks, ks ).    % Koivisto and Sood
loss_id( loss_naive_edgecount, ne ). 
loss_id( loss_kl, kl ). 	  % KL divergence

model_id( asia, as ).

prior_id( 'bn_or.slp', ts ).
prior_id( 'bn_or_2p_6h34.slp', tpt ).
prior_id( 'bn_or_any_pick_6h34.slp', po ).
prior_id( 'bn_or_any_pick_rcp_6h34.slp', pc ).
prior_id( 'bn_or_any_pick_ahalf_6h34.slp', hf ).
prior_id( 'bn_un_any_6h34.slp', lc ).

% lhood_id( '../bns/src/llhood/lhood_canonical_uai01.pl', ua ).
lhood_id( '../bns/src/llhood/lhood_canonical_bdeu.pl', bd ).

ds_of_two_to_script( S ) :-
	write( S, domain_size('_',2) ), write( S, '.' ), nl( S ),
	write( S, possible_values('_',[0,1]) ), write( S, '.' ), nl( S ),
	write( S, num_rvs(8) ), write( S, '.' ), nl( S ),
	write( S, ':- ensure_loaded( \'auxil/bns_scm\' ).' ), nl( S ).

list_of_first_n_nats( 0, Nats, Nats ) :- !.
list_of_first_n_nats( N, Acc, Nats ) :-
	DecN is N - 1,
	list_of_first_n_nats( DecN, [N|Acc], Nats ).
