:- module( ciex, [ci/4] ).

% From JC, beginning of August 2005. %% precede Nicos' comments.

:- use_module(library(ordsets)).
:- use_module(library(lists)).

% :- op( 100, xfx, '<-' ).

%% Unconnected code.

k([],[]).
k([RV|RVs],BN) :-                      %it's a Bayes net if ..
        k(RVs,TailBN),                 %this is and ..
        edges(RVs,RV,TailBN,BN).       %we connect RV thus giving BN

edges([],_RV,BN,BN).                   % finished
edges([H|T],RV,TailBN,BN) :-           % connect
        edges(T,RV,[H-RV|TailBN],BN).
        % edges(T,RV,[H<-RV|TailBN],BN).
edges([_H|T],RV,TailBN,BN) :-           % don't connect
        edges(T,RV,TailBN,BN).
%% End of Unconnected code.


ci(A,B,S,BN) :-
	ord_union([A,B,S],ABS),
	anm(ABS,[],BN,[],MN),
	sep(MN,A,B,S).

anm([],_Closed,_BN,In,In).
anm([Var|Rest],Closed,BN,In,Out) :-
	parents(BN,Var,Edges,Pas),
	marry(Pas,Marriages),
	ord_union([In,Edges,Marriages],Mid),
	ord_add_element(Closed,Var,NewClosed),
	ord_subtract(Pas,Closed,ToAdd),
	ord_union(ToAdd,Rest,Vars),
	anm(Vars,NewClosed,BN,Mid,Out).

/* %%
parents([],_Var,InE,InP,InE,InP).
parents([Var-Pa|T],Var,InE,InP,OutE,OutP) :-
% parents([Var<-Pa|T],Var,InE,InP,OutE,OutP) :-
	!,
	list_to_ord_set([Var,Pa],[V1,V2]),
	ord_add_element(InE,V1-V2,MidE),
	ord_add_element(InP,Pa,MidP),
	parents(T,Var,MidE,MidP,OutE,OutP).
parents([_|T],Var,InE,InP,OutE,OutP) :-
	parents(T,Var,InE,InP,OutE,OutP).
*/

parents([Var-Pa|_T],Var,Edges,Pa) :-
	!,
	var_edges( Pa, Var, Edges ).
parents([_|T],Var,OutE,OutP) :-
	parents(T,Var,OutE,OutP).

var_edges( [], _Var, [] ).
var_edges( [H|T], Var, [Var-H|Edges] ) :-
	var_edges( T, Var, Edges ).

marry(Pas,Marriages) :-
	setof(Pa1-Pa2,(
		       member(Pa1,Pas),
		       member(Pa2,Pas),
		       Pa1 @< Pa2
		      ),
	      Marriages
	     ),
	!.
marry(_,[]).
	

sep(MN,A,B,S) :-
	\+ path_avoiding_s(MN,A,B,S).

path_avoiding_s(MN,A,B,S) :-
	member(AElt,A),
	member(BElt,B),
	path(MN,AElt,BElt,[AElt|S]).

path(_,B,B,_).
path(MN,A,B,Closed) :-
	nb(A,X,MN,Rest),
	\+ member(X,Closed),
	path(Rest,X,B,[X|Closed]).

nb(A,X,MN,Rest) :-
	select(A-X,MN,Rest).
nb(A,X,MN,Rest) :-
	select(X-A,MN,Rest).

	
