:- ensure_loaded( '../../src/lib/kvs_replace_v_or_insert' ).

has_stats( [] ).
has_stats( [H|T] ) :-
	has_stats_1( H ),
	has_stats( T ).

has_stats_1( H ) :-
	( atom_concat(Stem,'.slp',H) ->
		true
		;
		Stem = H
	),
	atom_concat( Stem, '.slp', Slp ),
	open( Slp, read, In ),
	read( In, (sample(Vars):-Body) ),
	length( Vars, VarsNum ),
	count_body( Body, [], Counts ),
	nl, write( 'Number of Variables: ' ), write( VarsNum ), nl, nl,
	write_body_counts( Counts ).

count_body( (A,B), Acc, Counts ) :- 
	!,
	arg( 2, A, ParentVars ),
	length( ParentVars, PaV ),
	kvs_replace_v_or_insert( Acc, PaV, OldV, NewV, NxAcc ),
	( OldV == null__ -> 
		NewV is 1
		;
		NewV is OldV + 1
	),
	count_body( B, NxAcc, Counts ).
count_body( A, Acc, Counts ) :-
	arg( 2, A, ParentVars ),
	length( ParentVars, PaV ),
	kvs_replace_v_or_insert( Acc, PaV, OldV, NewV, Counts ),
	( OldV == null__ -> 
		NewV is 1
		;
		NewV is OldV + 1
	).
	
write_body_counts( [] ) :- nl.
write_body_counts( [K-Tms|T] ) :-
	write( '  ' ), write( Tms ), write( ' vars with ' ),
	write( K ), write( ' ' ), write( 'parents.' ), nl,
	write_body_counts( T ).
