:- ensure_loaded( '../../../src/sload' ).				% /1.
:- ensure_loaded( '../../../src/init_lib' ).
:- ensure_loaded( '../../../src/construct_scall' ).		% s/1.
:- ensure_loaded( '../../../auxil/all_models' ).		% path_to_prb/3.
:- ensure_loaded( library(flatten) ).		%.
:- ensure_loaded( library(write_terms) ).		%.


:- ensure_loaded( '../data/idsd' ).					% /4.

% When limiting depth to =< n at split_leaf we have m number of possible carts
% n     m
% 1     66 
% 2     57861
% 
appx_posterior( Files ) :-
	idsd( 3, kyph_train_080, Splits, Ids ),
	sload( ['../slps/ids_split.slp',rm(false)] ),
	appx_posterior_1( Files, Splits, Ids ).
	
appx_posterior_1( [], _Splits, _Ids ).
appx_posterior_1( [File|T], Splits, Ids ) :-
	open( File, read, In ),
	read( In, Term ),
	% read( Tms-c(Cart) ),
	appx_posterior_2( Term, Splits, Ids, In, 0, Tot, SApxPs ),
	atom_concat( Stem, '.mvisits', File ),
	atom_concat( Stem, '.smp_apx_post', PostFile ),
	appx_pairs_to_rec_terms( SApxPs, Tot, ApxTrms ),
	write_terms( PostFile, ApxTrms ),
	close( In ),
	appx_posterior_1( T, Splits, Ids ).

appx_posterior_2( end_of_file, _Splits, _Ids, _In, Tot,  Tot, [] ).
appx_posterior_2( Tms-c(Cart), Splits, Ids, In, AccT, Tot, SApxPrs ) :-
	Args = [Splits,Ids,0.95/1,Cart],
	trace,
	spec_constructs_scall( cart/4, ns, Path, Args, Call ),
	slp:Call,
	path_to_prb( Path, 1, Prb ),
	read( In, NxTrm ),
	NxAccT is AccT + Tms,
	SApxPrs = [Tms-Prb|TSApx],
	appx_posterior_2( NxTrm, Splits, Ids, In, NxAccT, Tot, TSApx ).

record_path( Path ) :-
	open( 'paths.pl', append, Out ),
	write( Out, Path ), write( Out, '.' ), nl( Out ),
	close( Out ).

appx_pairs_to_rec_terms( [], _Tot, [] ).
% appx_pairs_to_rec_terms( [Tms-Apx|T], Tot, [pst(Sample,Apx|R)] ) :-
appx_pairs_to_rec_terms( [Tms-Apx|T], Tot, [Pst|R] ) :-
	Sample is Tms / Tot,
	number_codes( Sample, SCs ), 
	number_codes( Apx, ACs ),
	flatten( [SCs,"  ",ACs], PstCs ),
	atom_codes( Pst, PstCs ),
	appx_pairs_to_rec_terms( T, Tot, R ).

	% old
depth_of_cart( cart(_,_,L,R), Dpth ) :-
	depth_of_cart( L, LDpth ),
	depth_of_cart( R, RDpth ),
	Dpth is max( LDpth, RDpth ) + 1.
depth_of_cart( leaf(_,_), 0 ).

