:- ensure_loaded( library(system) ).		% working_directory/2.
:- ensure_loaded( library(lists) ).		% append/3, memberchk/2.
:- ensure_loaded( '../../../src/init_lib' ).
:- ensure_loaded( library(requires) ).
:- elm( 'carts/auxil/test_classification' ).
% :- ensure_loaded( '../../../carts/auxil/test_classification' ).

:- requires( basename/2 ).
:- requires( directory_contents/4 ).
:- requires( file_stems_of_files_with_this_ext/3 ).
:- requires( flatoms/2 ).
:- requires( werr/1 ).
:- requires( sys_info/1 ).

:- prolog_load_context(directory,Dir),
   bb_put( icml_aux_dir, Dir ).

mk_predictions :-
	mk_predictions( [] ).

mk_predictions( InOpts ) :-
	mk_predictions_defaults( Defs ),
	append( InOpts, Defs, Opts ),
	working_directory( Here, Here ),
	basename( Here, LocDir ),
	dirname_train_test_index( LocDir, Train, Test ),
	directory_contents( '.', Files, _Dirs, _Oth ),
	file_stems_of_files_with_this_ext( Files, '.mvisits', Stems ),
	memberchk( upsh(UpshBin), Opts ),
	predictions_of_stems( Stems, Train, Test, UpshBin ).

mk_predictions_defaults( [upsh(Upsh)] ) :-
	( bb_get(upsh_exec,Upsh) -> true; Upsh=none).

%%% compile( '$HOME/islp/mcmcms/pbl/icml05/auxil/mk_predictions' ).

predictions_of_stems( [], _Train, _Test, _Ubin ).
predictions_of_stems( [H|T], Train, Test, Ubin ) :-
	( Ubin == none -> 
		atom_concat( H, '.mvisits', Hmvis ),
		TcOpts = [train(Train),output(pbc_pn),file(Hmvis),test(Test)],
		write( user_error, test_classification( TcOpts ) ),
		nl( user_error ),
		test_classification( TcOpts )
		;
		bb_get( icml_aux_dir, AuxDir ),
		TcRel = '/../../../carts/auxil/test_classification.pl ',
		atom_concat( AuxDir, TcRel, TcPl ),
		OutpF = ' output=pbc_pn file=',
		atom_concat( H, '.mvisits test=', HmvisTst ),
		flatoms( [Ubin,' ',TcPl,'train=',Train,OutpF,HmvisTst,Test], Upsh ),
		write( user_error, Upsh), nl( user_error ),
		sys_info( Upsh )
	),
	predictions_of_stems( T, Train, Test, Ubin ).

dirname_train_test_index( LocDir, Train, Test ) :-
	atom_codes( LocDir, LDCs ), 
	( append(_,[0'p,0'i,0'm,0'a|_],LDCs) -> 
		TestFile = 'pima_test_020.pl',
		Train    = icml_pima
		;
		( append(_,[0'b,0'c,0'w|_],LDCs) ->
			TestFile = 'bcw_test_020.pl',
			Train    = icml_bcw
			;
			( append(_,[0'k,0'y,0'p,0'h|_],LDCs) ->
				TestFile = 'kyph_test_020.pl',
				Train    = icml_kyph
				;
				( append(_,[0'l,0'e,0't,0'r,0'e,0'c|_],LDCs) ->
					TestFile = 'letter_recognition_test_020.pl',
					Train    = icml_letrec
					;
					( append(_,[0'w,0'f,0'o,0'r,0'm|_],LDCs) ->
						TestFile = 'waveform_noise_data_test_020.pl',
						Train    = icml_wform
						;
						werr( [['Cannt decipher test for dir: ',LocDir]] ),
						fail
					)
				)
			)
		)
	),
	bb_get( icml_aux_dir, AuxDir ),
	atom_concat( AuxDir, '/../data/', PfxDir ),
	atom_concat( PfxDir, TestFile, Test ).
