%
% :- requires( ).
%

unprotected_splits( List, Sep, Left, Right ) :-
   unprotected_splits( List, Sep, '', Left, Right ).

unprotected_splits( [Sep|T], Sep, _Quote, Left, Right ) :-
	!,
	Left = [], Right = T.
unprotected_splits( [H|T], Sep, Quote, Left, Right ) :-
	unprotected_splits_code( H, T, Quote, Rem, Left, TLeft ),
	unprotected_splits( Rem, Sep, Quote, TLeft, Right ).
	
unprotected_splits_code( 44, T, _Quote, Rem, Left, TLeft ) :-
	!,
	T = [Fst|Rem],
	Left = [44,Fst|TLeft].
unprotected_splits_code( 0'', T, Quote, Rem, Left, TLeft ) :-
	!,
   exclude_protection_code_if_quoted_by_it( 0'', Quote, Left, MidLeft ),
	% Left = [0''|MidLeft],
	unprotected_splits_until_sgl( T, Quote, Rem, MidLeft, TLeft ).
unprotected_splits_code( 0'", T, Quote, Rem, Left, TLeft ) :-
	!,
	exclude_protection_code_if_quoted_by_it( 0'", Quote, Left, MidLeft ),
   % Left = [0'"|MidLeft],
	unprotected_splits_until_dbl( T, Quote, Rem, MidLeft, TLeft ).
unprotected_splits_code( Code, T, _Quote, T, [Code|TLeft], TLeft ).

unprotected_splits_until_sgl( [H|T], _Quote, Rem, Left, TLeft ) :-
	unprotected_splits_until_sgl_code( H, T, Rem, Left, TLeft ).

unprotected_splits_until_sgl_code( 0'', T, Quote, Rem, Left, TLeft ) :-
	!,
	T = Rem,
   exclude_protection_code_if_quoted_by_it( 0'', Quote,  Left, TLeft ).
unprotected_splits_until_sgl_code( 44, T, Quote, Rem, Left, TLeft ) :-
	!,
	T = [Fst|Tail],
	Left = [44,Fst|RemLeft],
	unprotected_splits_until_sgl( Tail, Quote, Rem, RemLeft, TLeft ).
unprotected_splits_until_sgl_code( Code, T, Quote, Rem, [Code|RemLeft], TLeft ) :-
	unprotected_splits_until_sgl( T, Rem, Quote, RemLeft, TLeft ).

unprotected_splits_until_dbl( [H|T], Quote, Rem, Left, TLeft ) :-
	unprotected_splits_until_dbl_code( H, T, Quote, Rem, Left, TLeft ).

unprotected_splits_until_dbl_code( 0'", T, Quote, Rem, Left, TLeft ) :-
	!,
	T = Rem,
   exclude_protection_code_if_quoted_by_it( 0'", Quote,  Left, TLeft ).
unprotected_splits_until_dbl_code( 44, T, Quote, Rem, Left, TLeft ) :-
	!,
	T = [Fst|Tail],
	Left = [44,Fst|RemLeft],
	unprotected_splits_until_dbl( Tail, Quote, Rem, RemLeft, TLeft ).
unprotected_splits_until_dbl_code( Code, T, Quote, Rem, [Code|RemLeft], TLeft ) :-
	unprotected_splits_until_dbl( T, Quote, Rem, RemLeft, TLeft ).

exclude_protection_code_if_quoted_by_it( Quote, Quote, Left, MidLeft ) :- 
   !, 
   MidLeft = Left.
exclude_protection_code_if_quoted_by_it( Code, _Quote, Left, MidLeft ) :-
	Left = [Code|MidLeft].
